4.14. Running a compiled program
Prev | Chapter 4. Using GHC | Next

## 4.14. Running a compiled program

To make an executable program, the GHC system compiles your code and then links it with a non-trivial runtime system (RTS), which handles storage management, profiling, etc.

You have some control over the behaviour of the RTS, by giving special command-line arguments to your program.

When your Haskell program starts up, its RTS extracts command-line arguments bracketed between `+RTS` and `-RTS` as its own. For example:

    % ./a.out -f +RTS -p -S -RTS -h foo bar

The RTS will snaffle `-p` `-S` for itself, and the remaining arguments `-f -h foo bar` will be handed to your program if/when it calls `System.getArgs`.

No `-RTS` option is required if the runtime-system options extend to the end of the command line, as in this example:

    % hls -ltr /usr/etc +RTS -A5m

If you absolutely positively want all the rest of the options in a command line to go to the program (and not the RTS), use a `––RTS`.

As always, for RTS options that take `size`s: If the last character of `size` is a K or k, multiply by 1000; if an M or m, by 1,000,000; if a G or G, by 1,000,000,000. (And any wraparound in the counters is your fault!)

Giving a `+RTS -f` option will print out the RTS options actually available in your program (which vary, depending on how you compiled).

NOTE: since GHC is itself compiled by GHC, you can change RTS options in the compiler using the normal `+RTS ... -RTS` combination. eg. to increase the maximum heap size for a compilation to 128M, you would add `+RTS -M128m -RTS` to the command line.

### 4.14.1. Setting global RTS options

RTS options are also taken from the environment variable `GHCRTS`. For example, to set the maximum heap size to 128M for all GHC-compiled programs (using an `sh`-like shell):

       GHCRTS='-M128m'
       export GHCRTS

RTS options taken from the `GHCRTS` environment variable can be overridden by options given on the command line.

### 4.14.2. RTS options to control the garbage collector

There are several options to give you precise control over garbage collection. Hopefully, you won't need any of these in normal operation, but there are several things that can be tweaked for maximum performance.

`-A` `size`

  [Default: 256k] Set the allocation area size used by the garbage collector. The allocation area (actually generation 0 step 0) is fixed and is never resized (unless you use `-H`, below).

  Increasing the allocation area size may or may not give better performance (a bigger allocation area means worse cache behaviour but fewer garbage collections and less promotion).

  With only 1 generation (`-G1`) the `-A` option specifies the minimum allocation area, since the actual size of the allocation area will be resized according to the amount of data in the heap (see `-F`, below).

`-c`

  Use a compacting algorithm for collecting the oldest generation. By default, the oldest generation is collected using a copying algorithm; this option causes it to be compacted in-place instead. The compaction algorithm is slower than the copying algorithm, but the savings in memory use can be considerable.

  For a given heap size (using the `-H` option), compaction can in fact reduce the GC cost by allowing fewer GCs to be performed. This is more likely when the ratio of live data to heap size is high, say >30%.

  NOTE: compaction doesn't currently work when a single generation is requested using the `-G1` option.

`-c` `n`

  [Default: 30] Automatically enable compacting collection when the live data exceeds `n`% of the maximum heap size (see the `-M` option). Note that the maximum heap size is unlimited by default, so this option has no effect unless the maximum heap size is set with `-M` `size`.

`-F` `factor`

  [Default: 2] This option controls the amount of memory reserved for the older generations (and in the case of a two space collector the size of the allocation area) as a factor of the amount of live data. For example, if there was 2M of live data in the oldest generation when we last collected it, then by default we'll wait until it grows to 4M before collecting it again.

  The default seems to work well here. If you have plenty of memory, it is usually better to use `-H` `size` than to increase `-F` `factor`.

  The `-F` setting will be automatically reduced by the garbage collector when the maximum heap size (the `-M` `size` setting) is approaching.

`-G` `generations`

  [Default: 2] Set the number of generations used by the garbage collector. The default of 2 seems to be good, but the garbage collector can support any number of generations. Anything larger than about 4 is probably not a good idea unless your program runs for a long time, because the oldest generation will hardly ever get collected.

  Specifying 1 generation with `+RTS -G1` gives you a simple 2-space collector, as you would expect. In a 2-space collector, the `-A` option (see above) specifies the minimum allocation area size, since the allocation area will grow with the amount of live data in the heap. In a multi-generational collector the allocation area is a fixed size (unless you use the `-H` option, see below).

`-H` `size`

  [Default: 0] This option provides a “suggested heap size” for the garbage collector. The garbage collector will use about this much memory until the program residency grows and the heap size needs to be expanded to retain reasonable performance.

  By default, the heap will start small, and grow and shrink as necessary. This can be bad for performance, so if you have plenty of memory it's worthwhile supplying a big `-H` `size`. For improving GC performance, using `-H` `size` is usually a better bet than `-A` `size`.

`-k` `size`

  [Default: 1k] Set the initial stack size for new threads. Thread stacks (including the main thread's stack) live on the heap, and grow as required. The default value is good for concurrent applications with lots of small threads; if your program doesn't fit this model then increasing this option may help performance.

  The main thread is normally started with a slightly larger heap to cut down on unnecessary stack growth while the program is starting up.

`-K` `size`

  [Default: 8M] Set the maximum stack size for an individual thread to `size` bytes. This option is there purely to stop the program eating up all the available memory in the machine if it gets into an infinite loop.

`-m` `n`

  Minimum % `n` of heap which must be available for allocation. The default is 3%.

`-M` `size`

  [Default: unlimited] Set the maximum heap size to `size` bytes. The heap normally grows and shrinks according to the memory requirements of the program. The only reason for having this option is to stop the heap growing without bound and filling up all the available swap space, which at the least will result in the program being summarily killed by the operating system.

  The maximum heap size also affects other garbage collection parameters: when the amount of live data in the heap exceeds a certain fraction of the maximum heap size, compacting collection will be automatically enabled for the oldest generation, and the `-F` parameter will be reduced in order to avoid exceeding the maximum heap size.

`-s` `file` , `-S` `file`

  Write modest (`-s`) or verbose (`-S`) garbage-collector statistics into file `file`. The default `file` is ``program`.stat`. The `file` `stderr` is treated specially, with the output really being sent to `stderr`.

  This option is useful for watching how the storage manager adjusts the heap size based on the current amount of live data.

`-t`file``

  Write a one-line GC stats summary after running the program. This output is in the same format as that produced by the `-Rghc-timing` option.

  As with `-s`, the default `file` is ``program`.stat`. The `file` `stderr` is treated specially, with the output really being sent to `stderr`.

### 4.14.3. RTS options for profiling and Concurrent/Parallel Haskell

The RTS options related to profiling are described in Section 5.4.1, “RTS options for heap profiling”; and those for concurrent/parallel stuff, in Section 4.12.4, “RTS options for Parallel Haskell ”.

### 4.14.4. RTS options for hackers, debuggers, and over-interested souls

These RTS options might be used (a) to avoid a GHC bug, (b) to see “what's really happening”, or (c) because you feel like it. Not recommended for everyday use!

`-B`

  Sound the bell at the start of each (major) garbage collection.

  Oddly enough, people really do use this option! Our pal in Durham (England), Paul Callaghan, writes: “Some people here use it for a variety of purposes—honestly!—e.g., confirmation that the code/machine is doing something, infinite loop detection, gauging cost of recently added code. Certain people can even tell what stage [the program] is in by the beep pattern. But the major use is for annoying others in the same office…”

`-D` `num`

  An RTS debugging flag; varying quantities of output depending on which bits are set in `num`. Only works if the RTS was compiled with the `DEBUG` option.

`-r` `file`

  Produce “ticky-ticky” statistics at the end of the program run. The `file` business works just like on the `-S` RTS option (above).

  “Ticky-ticky” statistics are counts of various program actions (updates, enters, etc.) The program must have been compiled using `-ticky` (a.k.a. “ticky-ticky profiling”), and, for it to be really useful, linked with suitable system libraries. Not a trivial undertaking: consult the installation guide on how to set things up for easy “ticky-ticky” profiling. For more information, see Section 5.7, “Using “ticky-ticky” profiling (for implementors)”.

`-xc`

  (Only available when the program is compiled for profiling.) When an exception is raised in the program, this option causes the current cost-centre-stack to be dumped to `stderr`.

  This can be particularly useful for debugging: if your program is complaining about a `head []` error and you haven't got a clue which bit of code is causing it, compiling with `-prof -auto-all` and running with `+RTS -xc -RTS` will tell you exactly the call stack at the point the error was raised.

  The output contains one line for each exception raised in the program (the program might raise and catch several exceptions during its execution), where each line is of the form:

      < cc1, ..., ccn >

  each `cc`i is a cost centre in the program (see Section 5.1, “Cost centres and cost-centre stacks”), and the sequence represents the “call stack” at the point the exception was raised. The leftmost item is the innermost function in the call stack, and the rightmost item is the outermost function.

`-Z`

  Turn off “update-frame squeezing” at garbage-collection time. (There's no particularly good reason to turn it off, except to ensure the accuracy of certain data collected regarding thunk entry counts.)

### 4.14.5. “Hooks” to change RTS behaviour

GHC lets you exercise rudimentary control over the RTS settings for any given program, by compiling in a “hook” that is called by the run-time system. The RTS contains stub definitions for all these hooks, but by writing your own version and linking it on the GHC command line, you can override the defaults.

Owing to the vagaries of DLL linking, these hooks don't work under Windows when the program is built dynamically.

The hook `ghc_rts_opts`lets you set RTS options permanently for a given program. A common use for this is to give your program a default heap and/or stack size that is greater than the default. For example, to set `-H128m -K1m`, place the following definition in a C source file:

    char *ghc_rts_opts = "-H128m -K1m";

Compile the C file, and include the object file on the command line when you link your Haskell program.

These flags are interpreted first, before any RTS flags from the `GHCRTS` environment variable and any flags on the command line.

You can also change the messages printed when the runtime system “blows up,” e.g., on stack overflow. The hooks for these are as follows:

`void OutOfHeapHook (unsigned long, unsigned long)`

  The heap-overflow message.

`void StackOverflowHook (long int)`

  The stack-overflow message.

`void MallocFailHook (long int)`

  The message printed if `malloc` fails.

For examples of the use of these hooks, see GHC's own versions in the file `ghc/compiler/parser/hschooks.c` in a GHC source tree.

Prev | Up | Next
4.13. Platform-specific Flags | Home | 4.15. Generating and compiling External Core Files